package net.npaka.surfaceviewex;
import android.content.res.Resources;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

//T[tFCXr[̗p
public class SurfaceViewView extends SurfaceView 
    implements SurfaceHolder.Callback,Runnable {
    private SurfaceHolder holder;//T[tFCXz_[
    private Thread        thread;//Xbh

    private Bitmap image;//C[W
    private int    px=0; //XW
    private int    py=0; //YW
    private int    vx=10;//Xx
    private int    vy=10;//Yx
    
    //RXgN^
    public SurfaceViewView(Context context) {
        super(context);

        //摜̓ǂݍ
        Resources r=getResources();
        image=BitmapFactory.decodeResource(r,R.drawable.sample);  
                
        //T[tFCXz_[̐(2)
        holder=getHolder();
        holder.addCallback(this);
        holder.setFixedSize(480,762);
    }

    //T[tFCX̐(1)
    public void surfaceCreated(SurfaceHolder holder) {
        //Xbh̊Jn(3)
        thread=new Thread(this);
        thread.start();
    }

    //T[tFCX̕ύX(1)
    public void surfaceChanged(SurfaceHolder holder,
        int format,int w,int h) {
    }   
    
    //T[tFCX̔j(1)
    public void surfaceDestroyed(SurfaceHolder holder) {
        thread=null;
    }
      
    //Xbh̏
    public void run() {
        Canvas canvas;
        while(thread!=null) {
            //_uobt@Oi4j
            canvas=holder.lockCanvas();
            canvas.drawColor(Color.WHITE);
            canvas.drawBitmap(image,px-40,py-40,null);
            holder.unlockCanvasAndPost(canvas);
                
            //ړ
            if (px<0 || getWidth()<px) vx=-vx;
            if (py<0 || getHeight()<py) vy=-vy;
            px+=vx;
            py+=vy;
                
            //X[v(5)
            try {
                Thread.sleep(50);
            } catch (Exception e) {
            }
        }
    }
}