package net.npaka.fragmentex;
import android.os.Bundle;
import android.app.FragmentTransaction;
import android.app.ListFragment;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.app.Fragment;
import android.view.LayoutInflater;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.TextView;
import android.app.Activity;

//tOg̗p
public class FragmentEx extends Activity {
    //ANeBreBNɌĂ΂
    @Override
    protected void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //CAEg̎w(1)
        setContentView(R.layout.main);
    }
    
    //XgtOg̐(2)
    public static class TitlesFragment extends ListFragment {
        private int pos=-1;

        //ANeBreBɌĂ΂(3)
        @Override
        public void onActivityCreated(Bundle bundle) {
            super.onActivityCreated(bundle);
            setListAdapter(new ArrayAdapter<String>(getActivity(),
                android.R.layout.simple_list_item_activated_1, 
                new String[]{"y[W0","y[W1","y[W2"}));
            getListView().setChoiceMode(ListView.CHOICE_MODE_SINGLE);
            showDetails(0);
        }

        //XgvfNbNɌĂ΂
        @Override
        public void onListItemClick(ListView l,View v,int position,long id) {
            showDetails(position);
        }

        //ڍׂ̕\
        private void showDetails(int index) {
            getListView().setItemChecked(index,true);
            if (pos==index) return;
            
            //tOg̐؂芷(4)
            DetailsFragment fragment=DetailsFragment.newInstance(index);
            FragmentTransaction ft=getFragmentManager().beginTransaction();
            ft.replace(R.id.details,fragment);
            ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
            ft.commit();
            pos=index;
        }
    }
  
    //ڍ׃tOg
    public static class DetailsFragment extends Fragment {
        //CX^XɌĂ΂
        public static DetailsFragment newInstance(int index) {
            DetailsFragment fragment=new DetailsFragment();
            Bundle bundle=new Bundle();
            bundle.putInt("index",index);
            fragment.setArguments(bundle);
            return fragment;
        }

        //tOgɊ֘AÂr[ɌĂ΂(3)
        @Override
        public View onCreateView(LayoutInflater inflater,
            ViewGroup container,Bundle bundle) {
            if (container==null) return null;
            TextView textView=new TextView(getActivity());
            textView.setText("y[W"+
                getArguments().getInt("index",0)+"̏ڍ");
            textView.setTextSize(24);
            return textView;
        }
    }
}
