package net.npaka.optionmenuex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.LinearLayout;

//IvVj[
public class OptionMenuEx extends Activity {
    //j[ACeID
    private static final int 
        MENU_ITEM0=0,
        MENU_ITEM1=1,
        MENU_ITEM2=2;

    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 
    }

    //IvVj[̐(1)
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        
        //j[ACe0̒ǉ(2)
        MenuItem item0=menu.add(0,MENU_ITEM0,0,"ACe0");
        item0.setIcon(android.R.drawable.ic_menu_add);
        
        //j[ACe1̒ǉ
        MenuItem item1=menu.add(0,MENU_ITEM1,0,"ACe1");
        item1.setIcon(android.R.drawable.ic_menu_call);
        
        //j[ACe2̒ǉ
        MenuItem item2=menu.add(0,MENU_ITEM2,0,"ACe2");
        item2.setIcon(android.R.drawable.ic_menu_save);
        return true;
    }    

    //j[ACeICxg̏(3)
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case MENU_ITEM0:
                showDialog(this,"","ACe0");
                return true;
            case MENU_ITEM1:
                showDialog(this,"","ACe1");
                return true;
            case MENU_ITEM2:
                showDialog(this,"","ACe2");
                return true;
        }
        return true;
    }    
    
    //_CAO̕\
    private static void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    }
}