package net.npaka.dbproviderex;
import android.content.ContentProvider;
import android.content.Context;
import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.net.Uri;

//DB񋟂RecvoC_
public class DBProvider extends ContentProvider {
    private final static String DB_NAME ="test.db";//DB
    private final static String DB_TABLE="test";   //e[u
    private final static int    DB_VERSION=1;      //o[W
    
    private SQLiteDatabase db;//f[^x[X
    
    //RecvoC_̏
    @Override
    public boolean onCreate() {
        //f[^x[X̐(3)
        DBHelper dbHelper=new DBHelper(getContext());
        db=dbHelper.getWritableDatabase();
        return (db!=null);
    }

    //f[^x[X̃NG[(4)
    @Override
    public Cursor query(Uri uri,String[] columns,String selection, 
        String[] selectionArgs,String sortOrder) {
        return db.query(DB_TABLE,columns,selection,
            selectionArgs,null,null,null);
    }
    
    //f[^x[X̍XV(4)
    @Override
    public int update(Uri uri,ContentValues values, 
        String selection,String[] selectionArgs) {
        return db.update(DB_TABLE,values,null,null);
    }    
   
    //f[^x[X̑}(4)
    @Override
    public Uri insert(Uri uri,ContentValues values) {
        db.insert(DB_TABLE,"",values);
        return uri;
    }
    
    //f[^x[X̍폜(gp)
    @Override
    public int delete(Uri uri,String selection, 
        String[] selectionArgs) {
        return 0;
    }
    
    //ʂ̎擾(gp)
    @Override
    public String getType(Uri uri) {
        return null;
    }

    //f[^x[Xwp[̒`
    private static class DBHelper extends SQLiteOpenHelper {
        //RXgN^
        public DBHelper(Context context) {
            super(context,DB_NAME,null,DB_VERSION);
        }
        
        //f[^x[X̐
        @Override
        public void onCreate(SQLiteDatabase db) {
            db.execSQL("create table if not exists "+
                DB_TABLE+"(id text primary key,info text)");
        }

        //f[^x[X̃AbvO[h
        @Override
        public void onUpgrade(SQLiteDatabase db,
            int oldVersion,int newVersion) {
            db.execSQL("drop talbe if exists "+DB_TABLE);
            onCreate(db);
        }
    }  
}