package net.npaka.cameraex;
import android.content.Context;
import android.hardware.Camera;
import android.os.Environment;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import java.io.FileOutputStream;

//J̐
public class CameraView extends SurfaceView 
    implements SurfaceHolder.Callback,Camera.PictureCallback {
    private SurfaceHolder holder;//z_[
    private Camera        camera;//J
    
    //RXgN^
    public CameraView(Context context) {
        super(context);
        
        //T[tFCXz_[̐
        holder=getHolder();
        holder.addCallback(this);
        
        //vbVobbt@̎w(2)
        holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }

    //T[tFCXCxg̏
    public void surfaceCreated(SurfaceHolder holder) {
        //J̏(3)
        try {
            camera=Camera.open();
            camera.setPreviewDisplay(holder);
        } catch (Exception e) {
        }
    }

    //T[tFCXύXCxg̏
    public void surfaceChanged(SurfaceHolder holder,int format,int w,int h) {
        //Jvr[̊Jn(4)
        camera.startPreview();
    }
    
    //T[tFCXCxg̏
    public void surfaceDestroyed(SurfaceHolder holder) {
        //J̃vr[~(5)
        camera.setPreviewCallback(null);
        camera.stopPreview();
        camera.release();
        camera=null;
    }
    
    //^b`ɌĂ΂
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        if (event.getAction()==MotionEvent.ACTION_DOWN) {
            //J̃XN[Vbg̎擾(6)
            camera.takePicture(null,null,this); 
        }
        return true;
    }

    //ʐ^BeɌĂ΂
    public void onPictureTaken(byte[] data,Camera camera) {
        //SDJ[hւ̃f[^ۑ(7)
        try {
            String path=Environment.getExternalStorageDirectory()+
                "/test.jpg";
            data2file(data,path);
        } catch (Exception e) {
        }
        //vr[ĊJ
        camera.startPreview();
    }

    //oCgf[^t@C
    private void data2file(byte[] w,String fileName) 
        throws Exception {
        FileOutputStream out=null;
        try {
            out=new FileOutputStream(fileName);
            out.write(w);
            out.close();
        } catch (Exception e) {
            if (out!=null) out.close();
            throw e;
        }
    }

}