package net.npaka.mediaplayerex;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.media.MediaPlayer;
import android.view.MotionEvent;
import android.view.View;

//TEh̍Đ
public class MediaPlayerView extends View
    implements MediaPlayer.OnCompletionListener {
    private MediaPlayer player;//v[[

    //RXgN^
    public MediaPlayerView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);
        setFocusable(true);
        player=null;
    }

    //`掞ɌĂ΂
    @Override
    protected void onDraw(Canvas canvas) {
        Paint paint=new Paint();
        paint.setAntiAlias(true);
        paint.setTextSize(32);
        canvas.drawText("MediaPlayerEx",0,40,paint);
    }

    //^b`ɌĂ΂
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        if (event.getAction()==MotionEvent.ACTION_DOWN) {
            if (player==null) {
                playSound();
            } else {
                stopSound();
            }
        }
        return true;
    }

    //TEh̍Đ
    public void playSound() {
        try {
            stopSound();
            
            //fBAvC[̐(1)
            player=MediaPlayer.create(getContext(),R.raw.sample);
            
            //TEh̍Đ(2)
            player.seekTo(0);
            player.start();
            
            //TEh̍ĐXi[̎w(3)
            player.setOnCompletionListener(this);
        } catch (Exception e) {
        }
    }

    //TEh̒~
    public void stopSound() {
        try {
            if (player==null) return;

            //TEh̒~(4)
            player.stop();
            player.setOnCompletionListener(null);
            player.release();
            player=null;
        } catch (Exception e) {
        }
    }

    //TEhĐIɌĂ΂(3)
    public void onCompletion(MediaPlayer mediaPlayer) {
        stopSound();
    }
}