package net.npaka.checkboxex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Spinner;

//`FbN{bNXƃWI{^ƃXsi[
public class CheckBoxEx extends Activity 
    implements View.OnClickListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    
    private CheckBox   checkBox;  //`FbN{bNX
    private RadioGroup radioGroup;//WIO[v
    private Spinner    spinner;   //Xsi[
    private Button     button;    //{^
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);             

        //`FbN{bNX̐(1)
        checkBox=new CheckBox(this);
        checkBox.setText("`FbN{bNX");
        checkBox.setTextColor(Color.rgb(0,0,0));
        checkBox.setChecked(true);
        checkBox.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        layout.addView(checkBox);

        //WI{^0̐(2)
        RadioButton radio0=new RadioButton(this);
        radio0.setId(0);
        radio0.setText("WI{^0");
        radio0.setTextColor(Color.rgb(0,0,0));
        
        //WI{^1̐(2)
        RadioButton radio1=new RadioButton(this);
        radio1.setId(1);
        radio1.setText("WI{^1");
        radio1.setTextColor(Color.rgb(0,0,0));
        
        //WIO[v̐(2)
        radioGroup=new RadioGroup(this);
        radioGroup.addView(radio0);
        radioGroup.addView(radio1);     
        radioGroup.check(0);
        radioGroup.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        layout.addView(radioGroup);
        
        //Xsi[̐(3)
        ArrayAdapter<String> adapter=new ArrayAdapter<String>(
            this,android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(
            android.R.layout.simple_spinner_dropdown_item);
        String[] strs={"","","F"};
        for (int i=0;i<strs.length;i++) adapter.add(strs[i]);
        spinner=new Spinner(this);
        spinner.setAdapter(adapter);
        spinner.setSelection(0);
        spinner.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        layout.addView(spinner);

        //{^̐
        button=new Button(this);
        button.setText("ʕ\");
        button.setOnClickListener(this);
        button.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        layout.addView(button);
    }

    //{^NbNɌĂ΂
    public void onClick(View v) {
        //`FbN{bNXƃWI{^ƃXsi[̏Ԏ擾(1)(2)(3)
        showDialog(this,"",
            "`FbN{bNX>"+checkBox.isChecked()+"\n"+
            "WI{^>"+radioGroup.getCheckedRadioButtonId()+"\n"+
            "Xsi[>"+spinner.getSelectedItem());
    }    
    
    //_CAO̕\
    private static void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    }    
}