package net.npaka.nfcex;
import com.google.common.primitives.UnsignedBytes;
import android.app.Activity;
import android.graphics.Color;
import android.nfc.NfcAdapter;
import android.os.Bundle;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;

//NFC̗p
public class NFCEx extends Activity {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    private TextView textView;
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //eLXgr[̐
        textView=new TextView(this);
        textView.setTextSize(16.0f);
        textView.setTextColor(Color.rgb(0,0,0));
        textView.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        layout.addView(textView);
        
    }
    
    //AvJnɌĂ΂
    @Override
    public void onResume() {
        super.onResume();
        try {
            //FeliCa IDm̎擾(1)
            byte[] mID=getIntent().getByteArrayExtra(NfcAdapter.EXTRA_ID);             
            
            //oCgf[^16iɕϊ(2)
            String hexStr=data2hex(mID);
            textView.setText("NFCEx>"+hexStr);
        } catch (Exception e) {
            textView.setText("NFCEx>");
        }
    }
    
    //oCgf[^16iɕϊ(2)
    private String data2hex(byte[] data) {
        StringBuilder sb=new StringBuilder();
        for (int i=0;i<data.length;i++) {
            String str=Integer.toHexString(
                UnsignedBytes.toInt(data[i]));
            if (str.length()==1) sb.append("0");
            sb.append(str);
        }
        return sb.toString();
    }
}