package net.npaka.socketex;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

//\PbgʐM
public class SocketEx extends Activity    
    implements View.OnClickListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int FP=LinearLayout.LayoutParams.FILL_PARENT;
    
    //IPAhX̎w(1)
    private final static String IP="192.168.11.12";//ύXK{
    
    private TextView lblReceive;//Mx
    private EditText edtSend;   //MGfBbgeLXg
    private Button   btnSend;   //M{^
    
    private Socket       socket; //\Pbg
    private InputStream  in;     //̓Xg[
    private OutputStream out;    //o̓Xg[  
    
    private final Handler handler=new Handler();//nh(3)
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 
        
        //MGfBbgeLXg̐
        edtSend=new EditText(this);
        edtSend.setId(2);
        edtSend.setText("",TextView.BufferType.NORMAL);
        edtSend.setLayoutParams(new LinearLayout.LayoutParams(FP,WC));
        layout.addView(edtSend);
        
        //M{^̐
        btnSend=new Button(this);
        btnSend.setText("M");
        btnSend.setOnClickListener(this);
        btnSend.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        layout.addView(btnSend);

        //Mx̐
        lblReceive=new TextView(this);
        lblReceive.setId(1);
        lblReceive.setText("");
        lblReceive.setTextSize(16.0f);
        lblReceive.setTextColor(Color.rgb(0,0,0));
        lblReceive.setLayoutParams(new LinearLayout.LayoutParams(FP,WC));        
        layout.addView(lblReceive);        
    }

    //ANeBreBJnɌĂ΂
    @Override
    public void onStart() {
        super.onStart();
        
        //Xbh̐(2)
        Thread thread=new Thread(){
            public void run() {
                try {
                    connect(IP,8080);
                } catch (Exception e) {
                }
            }
        };
        thread.start();
    }
    
    //ANeBreB̒~ɌĂ΂
    @Override
    public void onStop() {
        super.onStop();
        disconnect();
    }
    
    //MeLXg̒ǉ
    private void addText(final String text) {
        //nh̐(3)
        handler.post(new Runnable(){
            public void run() {
                lblReceive.setText(text+"\n"+
                    lblReceive.getText());
            }
        });
    }
    
    //ڑ
    private void connect(String ip,int port) {
        int size;
        String str;
        byte[] w=new byte[1024];        
        try {
            //\Pbgڑ(4)
            addText("ڑ");
            socket=new Socket(ip,port);
            in =socket.getInputStream();
            out=socket.getOutputStream();
            addText("ڑ");
            
            //M[v(5)
            while (socket!=null && socket.isConnected()) {
                //f[^̎M(6)
                size=in.read(w);
                if (size<=0) continue;
                str=new String(w,0,size,"UTF-8");

                //xւ̕ǉ
                addText(str);
            }
        } catch (Exception e) {
            addText("ʐMs܂");
        }
    }
    
    //ؒf
    private void disconnect() {
        try {
            socket.close();
            socket=null;
        } catch (Exception e) {
        }
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        if (v==btnSend) {
            try {
                //f[^̑M(7)
                if (socket!=null && socket.isConnected()) {
                    byte[] w=edtSend.getText().toString().getBytes("UTF8");
                    out.write(w);
                    out.flush();
                    edtSend.setText("",TextView.BufferType.NORMAL);
                }
            } catch (Exception e) {
                addText("ʐMs܂");
            }           
        }
    }
}