package net.npaka.fileproviderex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

//t@C񋟂RecvoC_̗p
public class FileProviderEx extends Activity implements
    View.OnClickListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int FP=LinearLayout.LayoutParams.FILL_PARENT;
    private EditText editText;
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);      
        
        //GfBbgeLXg̐
        editText=new EditText(this);
        editText.setLayoutParams(new LinearLayout.LayoutParams(FP,WC));
        layout.addView(editText);

        //{^̐
        layout.addView(makeButton("RecvoC_ʐM","read"));
    }   

    //{^̐
    private Button makeButton(String text,String tag) {
        Button button=new Button(this);
        button.setText(text);
        button.setTag(tag);
        button.setOnClickListener(this);
        button.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        return button;
    }
    
    //{^NbNɌĂ΂
    public void onClick(View v) {
        String tag=(String)v.getTag();
        if (tag.equals("read")) {
            try {
                //RecvoC_񋟂t@Cւ̃ANZX(1)
                InputStream in=getContentResolver().openInputStream(Uri.parse(
                    "content://net.npaka.fileprovider/test"));
                
                String str=new String(in2data(in));
                editText.setText(str,TextView.BufferType.EDITABLE);
            } catch (Exception e) {
                showDialog(this,"G[","ǂݍݎs܂ "+e.toString());
            }            
        }
    }    

    //̓Xg[f[^
    public static byte[] in2data(InputStream in) 
        throws Exception { 
        byte[] w=new byte[1024]; 
        ByteArrayOutputStream out=new ByteArrayOutputStream();
        try {
            while (true) { 
                int size=in.read(w);
                if (size<=0) break; 
                out.write(w,0,size); 
            };
            out.close();
            in.close();
            return out.toByteArray();
        } catch (Exception e) {
            try {
                if (in !=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    }

    //_CAO̕\
    private static void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    } 
}