package net.npaka.locationex;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.Window;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapView;
import com.google.android.maps.MapController;

//ʒu̎擾
public class LocationEx extends MapActivity 
    implements LocationListener {
    private final static String API_KEY=//APIL[(1)
        "[Android Maps API Key]";
    
    private MapView         mapView;//Mapr[  
    private MapController   mapCtrl;//MapRg[
    private LocationManager lm;     //P[V}l[W
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //Mapr[̐
        mapView=new MapView(this,API_KEY);
        setContentView(mapView);
        mapCtrl=mapView.getController();
        mapCtrl.setZoom(16);
    }

    //ANeBreBJnɌĂ΂
    @Override
    public void onStart() {
        super.onStart();
        //P[V}l[W̐ݒ(2)
        lm=(LocationManager)getSystemService(Context.LOCATION_SERVICE);
        lm.requestLocationUpdates(LocationManager.NETWORK_PROVIDER,0,0,this);
    }

    //ANeBreB~ɌĂ΂
    @Override
    public void onStop() {
        super.onStop();
        
        //P[V}l[W[̐ݒ(2)
        lm.removeUpdates(this);
    }
    
    //[g\邩ǂ
    @Override
    protected boolean isRouteDisplayed() {
        return false;
    }

    //ʒuύX̃Cxg(3)
    public void onLocationChanged(Location location) {
        //ܓxƌox̎擾(4)
        GeoPoint pos=new GeoPoint(
            (int)(location.getLatitude()*1E6),
            (int)(location.getLongitude()*1E6));
        mapCtrl.setCenter(pos);
    }

    //ʒu擾L̃Cxg̏(3)
    public void onProviderEnabled(String provider) {
    }

    //ʒu擾̃Cxg(3)
    public void onProviderDisabled(String provider) {
    }

    //ʒuԕύX̃Cxg(3)
    public void onStatusChanged(String provider,
        int status,Bundle extras) {
    }
}