package net.npaka.mediarecorderex;
import java.io.File;
import android.app.Activity;
import android.graphics.Color;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.os.Environment;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;

//
public class AudioActivity extends Activity {
    private MediaRecorder recorder; //fBAR[_[
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //eLXgr[̐
        TextView textView=new TextView(this);
        textView.setText("^(BACKŏI)");
        textView.setTextSize(16.0f);
        textView.setTextColor(Color.rgb(0,0,0));
        layout.addView(textView);

        try {
            //^̊Jn(1)
            recorder=new MediaRecorder();
            recorder.setAudioSource(MediaRecorder.AudioSource.MIC);
            recorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
            recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);
            File dir=Environment.getExternalStorageDirectory();
            File file=File.createTempFile("test",".3gp",dir);
            recorder.setOutputFile(file.getAbsolutePath());
            recorder.prepare();
            recorder.start();
       } catch (Exception e) {
            android.util.Log.e("",e.toString());
        }
    }

    //Av̒~
    @Override
    public void onStop() {
        super.onStop();
        try {
            //^̒~(2)
            recorder.stop();
            recorder.release();
        } catch (Exception e) {
        }
    }
}