package net.npaka.texttospeechex;
import java.util.Locale;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.speech.tts.TextToSpeech;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

//
public class TextToSpeechEx extends Activity 
    implements View.OnClickListener,TextToSpeech.OnInitListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int FP=LinearLayout.LayoutParams.FILL_PARENT;
    private EditText     editText;//GfBbgeLXg
    private TextToSpeech tts;     //TTS
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //GfBbgeLXg̐
        editText=new EditText(this);
        editText.setText("This is TEST!",EditText.BufferType.NORMAL);
        editText.setLayoutParams(new LinearLayout.LayoutParams(FP,WC));
        layout.addView(editText);
        
        //{^̐
        layout.addView(makeButton("","speech"));
        
        //̏(1)
        tts=new TextToSpeech(this,this);
    }
    
    //{^̐
    private Button makeButton(String text,String tag) {
        Button button=new Button(this);
        button.setText(text);
        button.setTag(tag);
        button.setOnClickListener(this);
        button.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        return button;
    }      

    //̏ɌĂ΂(1)
    public void onInit(int status) {
        if (status==TextToSpeech.SUCCESS) {
            //̃P[w(2)
            Locale locale=Locale.ENGLISH;
            if (tts.isLanguageAvailable(locale)>=
                TextToSpeech.LANG_AVAILABLE) {
                tts.setLanguage(locale);
            } else {
                toast("Unsupported Language");
            }
        } else if (status==TextToSpeech.ERROR) {
            toast("TextToSpeech.ERROR");
        }
    }

    //ANeBreBjɌĂ΂
    protected void onDestroy() {
        super.onDestroy();
        
        //̏I(4)
        if (tts!=null) tts.shutdown();
    }
    
    //g[Xg̕\
    private void toast(String text) {
        Toast.makeText(TextToSpeechEx.this,text,Toast.LENGTH_LONG).show();
    }
    
    //{^NbNɌĂ΂
    public void onClick(View v) {
        String str=editText.getText().toString();
        if (str.length()==0) return;
        //Xs[`̒~
        if (tts.isSpeaking())tts.stop();
            
        //Xs[`̍Đ
        tts.setSpeechRate(1.0f);
        tts.speak(str,TextToSpeech.QUEUE_FLUSH,null);
    }    
}