package net.npaka.relativelayoutex;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.view.Window;
import android.widget.Button;
import android.widget.RelativeLayout;

//CeBuCAEg
public class RelativeLayoutEx extends Activity {
    private final static int WC=RelativeLayout.LayoutParams.WRAP_CONTENT;

    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        RelativeLayout layout=new RelativeLayout(this);
        layout.setBackgroundColor(Color.WHITE);
        setContentView(layout);        

        //{^1̐
        Button button1=new Button(this);
        button1.setId(1);
        button1.setText("(1)");
        button1.setLayoutParams(new RelativeLayout.LayoutParams(200,WC));
        layout.addView(button1);
        
        //{^2̐
        Button button2=new Button(this);
        button2.setId(2);
        button2.setText("(2) 1̉");
        RelativeLayout.LayoutParams params2;
        params2=new RelativeLayout.LayoutParams(200,WC);
        params2.addRule(RelativeLayout.BELOW,1);//1̉
        button2.setLayoutParams(params2);
        layout.addView(button2);

        //{^3̐
        Button button3=new Button(this);
        button3.setId(3);
        button3.setText("(3) 1̉ 2̉E");
        RelativeLayout.LayoutParams params3;
        params3=new RelativeLayout.LayoutParams(200,WC);
        params3.addRule(RelativeLayout.BELOW,1);//1̉
        params3.addRule(RelativeLayout.RIGHT_OF,2);//2̉E
        button3.setLayoutParams(params3);
        layout.addView(button3);
        
        //{^4̐
        Button button4=new Button(this);
        button4.setId(4);
        button4.setText("(4) 2̉E 3̉");
        RelativeLayout.LayoutParams params4;
        params4=new RelativeLayout.LayoutParams(200,WC);
        params4.addRule(RelativeLayout.RIGHT_OF,2);//2̉E
        params4.addRule(RelativeLayout.BELOW,3);//3̉
        button4.setLayoutParams(params4);
        layout.addView(button4);
    }
}